/**
 * POCDMT000040ParticipantRole.java
 *
 * File generated from the cda::POCDMT000040ParticipantRole uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.cdaxehealth;

import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import net.ihe.gazelle.gen.common.ConstraintValidatorModule;

import net.ihe.gazelle.ips.datatypes.CE;
import net.ihe.gazelle.ips.datatypes.CS;
import org.w3c.dom.Document;
import org.w3c.dom.Node;


/**
 * Description of the class POCDMT000040ParticipantRole.
 *
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "POCD_MT000040.ParticipantRole", propOrder = {
	"realmCode",
	"typeId",
	"templateId",
	"id",
	"code",
	"addr",
	"telecom",
	"playingDevice",
	"playingEntity",
	"scopingEntity",
	"classCode",
	"nullFlavor"
})
@XmlRootElement(name = "POCD_MT000040.ParticipantRole")
public class POCDMT000040ParticipantRole implements java.io.Serializable {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	
	@XmlElement(name = "realmCode", namespace = "urn:hl7-org:v3")
	public List<CS > realmCode;
	@XmlElement(name = "typeId", namespace = "urn:hl7-org:v3")
	public POCDMT000040InfrastructureRootTypeId typeId;
	@XmlElement(name = "templateId", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.ips.datatypes.II> templateId;
	@XmlElement(name = "id", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.ips.datatypes.II> id;
	@XmlElement(name = "code", namespace = "urn:hl7-org:v3")
	public CE code;
	@XmlElement(name = "addr", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.ips.datatypes.AD> addr;
	@XmlElement(name = "telecom", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.ips.datatypes.TEL> telecom;
	@XmlElement(name = "playingDevice", namespace = "urn:hl7-org:v3")
	public POCDMT000040Device playingDevice;
	@XmlElement(name = "playingEntity", namespace = "urn:hl7-org:v3")
	public POCDMT000040PlayingEntity playingEntity;
	@XmlElement(name = "scopingEntity", namespace = "urn:hl7-org:v3")
	public POCDMT000040Entity scopingEntity;
	@XmlAttribute(name = "classCode")
	public net.ihe.gazelle.voc.RoleClassRoot classCode;
	@XmlAttribute(name = "nullFlavor")
	public net.ihe.gazelle.voc.NullFlavor nullFlavor;
	@XmlTransient
	private Object __parent;
	
	void afterUnmarshal( javax.xml.bind.Unmarshaller u, Object parent ){
		this.__parent = parent;
	}
	
	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	private Node _xmlNodePresentation;
	
	
	/**
	 * Return realmCode.
	 * @return realmCode
	 */
	public List<CS > getRealmCode() {
		if (realmCode == null) {
	        realmCode = new ArrayList<CS >();
	    }
	    return realmCode;
	}
	
	/**
	 * Set a value to attribute realmCode.
	 * @param realmCode.
	 */
	public void setRealmCode(List<CS > realmCode) {
	    this.realmCode = realmCode;
	}
	
	
	
	/**
	 * Add a realmCode to the realmCode collection.
	 * @param realmCode_elt Element to add.
	 */
	public void addRealmCode(CS realmCode_elt) {
	    this.getRealmCode().add(realmCode_elt);
	}
	
	/**
	 * Remove a realmCode to the realmCode collection.
	 * @param realmCode_elt Element to remove
	 */
	public void removeRealmCode(CS realmCode_elt) {
	    this.getRealmCode().remove(realmCode_elt);
	}
	
	/**
	 * Return typeId.
	 * @return typeId
	 */
	public POCDMT000040InfrastructureRootTypeId getTypeId() {
	    return typeId;
	}
	
	/**
	 * Set a value to attribute typeId.
	 * @param typeId.
	 */
	public void setTypeId(POCDMT000040InfrastructureRootTypeId typeId) {
	    this.typeId = typeId;
	}
	
	
	
	
	/**
	 * Return templateId.
	 * @return templateId
	 */
	public List<net.ihe.gazelle.ips.datatypes.II> getTemplateId() {
		if (templateId == null) {
	        templateId = new ArrayList<net.ihe.gazelle.ips.datatypes.II>();
	    }
	    return templateId;
	}
	
	/**
	 * Set a value to attribute templateId.
	 * @param templateId.
	 */
	public void setTemplateId(List<net.ihe.gazelle.ips.datatypes.II> templateId) {
	    this.templateId = templateId;
	}
	
	
	
	/**
	 * Add a templateId to the templateId collection.
	 * @param templateId_elt Element to add.
	 */
	public void addTemplateId(net.ihe.gazelle.ips.datatypes.II templateId_elt) {
	    this.getTemplateId().add(templateId_elt);
	}
	
	/**
	 * Remove a templateId to the templateId collection.
	 * @param templateId_elt Element to remove
	 */
	public void removeTemplateId(net.ihe.gazelle.ips.datatypes.II templateId_elt) {
	    this.getTemplateId().remove(templateId_elt);
	}
	
	/**
	 * Return id.
	 * @return id
	 */
	public List<net.ihe.gazelle.ips.datatypes.II> getId() {
		if (id == null) {
	        id = new ArrayList<net.ihe.gazelle.ips.datatypes.II>();
	    }
	    return id;
	}
	
	/**
	 * Set a value to attribute id.
	 * @param id.
	 */
	public void setId(List<net.ihe.gazelle.ips.datatypes.II> id) {
	    this.id = id;
	}
	
	
	
	/**
	 * Add a id to the id collection.
	 * @param id_elt Element to add.
	 */
	public void addId(net.ihe.gazelle.ips.datatypes.II id_elt) {
	    this.getId().add(id_elt);
	}
	
	/**
	 * Remove a id to the id collection.
	 * @param id_elt Element to remove
	 */
	public void removeId(net.ihe.gazelle.ips.datatypes.II id_elt) {
	    this.getId().remove(id_elt);
	}
	
	/**
	 * Return code.
	 * @return code
	 */
	public CE getCode() {
	    return code;
	}
	
	/**
	 * Set a value to attribute code.
	 * @param code.
	 */
	public void setCode(CE code) {
	    this.code = code;
	}
	
	
	
	
	/**
	 * Return addr.
	 * @return addr
	 */
	public List<net.ihe.gazelle.ips.datatypes.AD> getAddr() {
		if (addr == null) {
	        addr = new ArrayList<net.ihe.gazelle.ips.datatypes.AD>();
	    }
	    return addr;
	}
	
	/**
	 * Set a value to attribute addr.
	 * @param addr.
	 */
	public void setAddr(List<net.ihe.gazelle.ips.datatypes.AD> addr) {
	    this.addr = addr;
	}
	
	
	
	/**
	 * Add a addr to the addr collection.
	 * @param addr_elt Element to add.
	 */
	public void addAddr(net.ihe.gazelle.ips.datatypes.AD addr_elt) {
	    this.getAddr().add(addr_elt);
	}
	
	/**
	 * Remove a addr to the addr collection.
	 * @param addr_elt Element to remove
	 */
	public void removeAddr(net.ihe.gazelle.ips.datatypes.AD addr_elt) {
	    this.getAddr().remove(addr_elt);
	}
	
	/**
	 * Return telecom.
	 * @return telecom
	 */
	public List<net.ihe.gazelle.ips.datatypes.TEL> getTelecom() {
		if (telecom == null) {
	        telecom = new ArrayList<net.ihe.gazelle.ips.datatypes.TEL>();
	    }
	    return telecom;
	}
	
	/**
	 * Set a value to attribute telecom.
	 * @param telecom.
	 */
	public void setTelecom(List<net.ihe.gazelle.ips.datatypes.TEL> telecom) {
	    this.telecom = telecom;
	}
	
	
	
	/**
	 * Add a telecom to the telecom collection.
	 * @param telecom_elt Element to add.
	 */
	public void addTelecom(net.ihe.gazelle.ips.datatypes.TEL telecom_elt) {
	    this.getTelecom().add(telecom_elt);
	}
	
	/**
	 * Remove a telecom to the telecom collection.
	 * @param telecom_elt Element to remove
	 */
	public void removeTelecom(net.ihe.gazelle.ips.datatypes.TEL telecom_elt) {
	    this.getTelecom().remove(telecom_elt);
	}
	
	/**
	 * Return playingDevice.
	 * @return playingDevice
	 */
	public POCDMT000040Device getPlayingDevice() {
	    return playingDevice;
	}
	
	/**
	 * Set a value to attribute playingDevice.
	 * @param playingDevice.
	 */
	public void setPlayingDevice(POCDMT000040Device playingDevice) {
	    this.playingDevice = playingDevice;
	}
	
	
	
	
	/**
	 * Return playingEntity.
	 * @return playingEntity
	 */
	public POCDMT000040PlayingEntity getPlayingEntity() {
	    return playingEntity;
	}
	
	/**
	 * Set a value to attribute playingEntity.
	 * @param playingEntity.
	 */
	public void setPlayingEntity(POCDMT000040PlayingEntity playingEntity) {
	    this.playingEntity = playingEntity;
	}
	
	
	
	
	/**
	 * Return scopingEntity.
	 * @return scopingEntity
	 */
	public POCDMT000040Entity getScopingEntity() {
	    return scopingEntity;
	}
	
	/**
	 * Set a value to attribute scopingEntity.
	 * @param scopingEntity.
	 */
	public void setScopingEntity(POCDMT000040Entity scopingEntity) {
	    this.scopingEntity = scopingEntity;
	}
	
	
	
	
	/**
	 * Return classCode.
	 * @return classCode
	 */
	public net.ihe.gazelle.voc.RoleClassRoot getClassCode() {
	    return classCode;
	}
	
	/**
	 * Set a value to attribute classCode.
	 * @param classCode.
	 */
	public void setClassCode(net.ihe.gazelle.voc.RoleClassRoot classCode) {
	    this.classCode = classCode;
	}
	
	
	
	
	/**
	 * Return nullFlavor.
	 * @return nullFlavor
	 */
	public net.ihe.gazelle.voc.NullFlavor getNullFlavor() {
	    return nullFlavor;
	}
	
	/**
	 * Set a value to attribute nullFlavor.
	 * @param nullFlavor.
	 */
	public void setNullFlavor(net.ihe.gazelle.voc.NullFlavor nullFlavor) {
	    this.nullFlavor = nullFlavor;
	}
	
	
	
	
	/**
	 * Return __parent.
	 * @return __parent
	 */
	public Object get__parent() {
	    return __parent;
	}
	
	/**
	 * Set a value to attribute __parent.
	 * @param __parent.
	 */
	public void set__parent(Object __parent) {
	    this.__parent = __parent;
	}
	
	
	
	
	
	public Node get_xmlNodePresentation() {
		if (_xmlNodePresentation == null){
				JAXBContext jc;
				DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
				dbf.setNamespaceAware(true);
				DocumentBuilder db = null;
				Document doc = null;
				try {
					db = dbf.newDocumentBuilder();
					doc = db.newDocument();
				} catch (ParserConfigurationException e1) {}
				try {
					jc = JAXBContext.newInstance("net.ihe.gazelle.cdaxehealth");
					Marshaller m = jc.createMarshaller();
					m.marshal(this, doc);
					_xmlNodePresentation = doc.getElementsByTagNameNS("urn:hl7-org:v3", "POCD_MT000040.ParticipantRole").item(0);
				} catch (JAXBException e) {
					try{
						db = dbf.newDocumentBuilder();
						_xmlNodePresentation = db.newDocument();
					}
					catch(Exception ee){}
				}
			}
			return _xmlNodePresentation;
	}
	
	public void set_xmlNodePresentation(Node _xmlNodePresentation) {
		this._xmlNodePresentation = _xmlNodePresentation;
	}
	
	
	

	
	/**
     * validate by a module of validation
     * 
     */
   public static void validateByModule(POCDMT000040ParticipantRole pOCDMT000040ParticipantRole, String _location, ConstraintValidatorModule cvm, List<net.ihe.gazelle.validation.Notification> diagnostic){
   		if (pOCDMT000040ParticipantRole != null){
   			cvm.validate(pOCDMT000040ParticipantRole, _location, diagnostic);
			{
				int i = 0;
				for (CS realmCode: pOCDMT000040ParticipantRole.getRealmCode()){
					CS .validateByModule(realmCode, _location + "/realmCode[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			POCDMT000040InfrastructureRootTypeId.validateByModule(pOCDMT000040ParticipantRole.getTypeId(), _location + "/typeId", cvm, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.ips.datatypes.II templateId: pOCDMT000040ParticipantRole.getTemplateId()){
					net.ihe.gazelle.ips.datatypes.II.validateByModule(templateId, _location + "/templateId[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.ips.datatypes.II id: pOCDMT000040ParticipantRole.getId()){
					net.ihe.gazelle.ips.datatypes.II.validateByModule(id, _location + "/id[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			CE .validateByModule(pOCDMT000040ParticipantRole.getCode(), _location + "/code", cvm, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.ips.datatypes.AD addr: pOCDMT000040ParticipantRole.getAddr()){
					net.ihe.gazelle.ips.datatypes.AD.validateByModule(addr, _location + "/addr[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.ips.datatypes.TEL telecom: pOCDMT000040ParticipantRole.getTelecom()){
					net.ihe.gazelle.ips.datatypes.TEL.validateByModule(telecom, _location + "/telecom[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			POCDMT000040Device.validateByModule(pOCDMT000040ParticipantRole.getPlayingDevice(), _location + "/playingDevice", cvm, diagnostic);
			POCDMT000040PlayingEntity.validateByModule(pOCDMT000040ParticipantRole.getPlayingEntity(), _location + "/playingEntity", cvm, diagnostic);
			POCDMT000040Entity.validateByModule(pOCDMT000040ParticipantRole.getScopingEntity(), _location + "/scopingEntity", cvm, diagnostic);
    	}
    }

}